using System;
using System.Collections;
using System.Text;
using System.Globalization;

namespace Aoyama.Rs232.Omron
{
	/// <summary>
	/// VvʐM For OMRON@p@Cu
	/// Ver 0.90
	/// 쐬@RZp@R
	/// 쐬 2007/1/24
	/// </summary>
	public class mdlOmron
	{

		/// <summary>
		/// eXg֐@Mf[^AMł邩eXg܂B
		/// </summary>
		/// <param name="rs">Rg[̃IuWFNg</param>
		/// <param name="sendData">Mf[^</param>
		/// <returns>Mf[^</returns>
		public static string Test(Omron rs, string sendData)
		{
			StringBuilder str = new StringBuilder("@");
			str.Append(rs.MachineNo.ToString("00"));
			str.Append("TS");
			str.Append(sendData);
			string ret = rs.SendExsyn(str.ToString(), 0);
			int l = ret.Length;
			string recData = ret.Substring(5, l - 8);
			return recData;
		}

		/// <summary>
		/// [ǂݍ
		/// </summary>
		/// <param name="rs">Rg[̃IuWFNg</param>
		/// <param name="ch">`l</param>
		/// <returns>l</returns>
		public static long RRs(Omron rs, long ch)
		{
			long[] data = rs.ReadRs(ch, 1);
			return data[0];
		}

		/// <summary>
		/// [
		/// </summary>
		/// <param name="rs">Rg[̃IuWFNg</param>
		/// <param name="ch">`l</param>
		/// <param name="val">l</param>
		/// <returns>Itrue</returns>
		public static bool WRs(Omron rs, long ch, long val)
		{
			try
			{
				long[] data = new long[] {val};
				rs.WriteRs(ch, data);
				return true;
			}
			catch(Exception ex)
			{
				return false;
			}
		}

		public struct cmdList
		{
			public int area;
			public int ch;
			public int op;

			void Set(int area, int ch, int op)
			{
				this.area = area;
				this.ch = ch;
				this.op = op;
			}
		}

		public static bool WriteQQ(Omron rs, cmdList[] cmds)
		{
			StringBuilder str = new StringBuilder("@");
			str.Append(rs.MachineNo.ToString("00"));
			str.Append("QQMR");

			if(rs.Ready == false) return false;

			ArrayList ar = new ArrayList(); 
			int n = cmds.Length;
			int i;
			for(i = 0; i < n; i++)
			{
				StringBuilder cmd = new StringBuilder();
				if((100 <= cmds[i].area) && (cmds[i].area <= 115))
				{
					// f[^
					cmd.Append("EM");
					int ma = cmds[i].area - 100;
					cmd.Append(ma.ToString("X2"));
				}
				else
				{
					switch(cmds[i].area)
					{
						case 1:	// o̓[A⏕[A⏕[
							cmd.Append("CIO ");
							break;
						case 2:	// N[
							cmd.Append("LR  ");
							break;
						case 3: // ێ[
							cmd.Append("HR  ");
							break;
						case 4: // ⏕L[
							cmd.Append("AR  ");
							break;
						case 5:	// ^C}
							cmd.Append("TIM ");
							break;
						case 6: // ^C}
							cmd.Append("TIMH");
							break;
						case 7: // JE^
							cmd.Append("CNT ");
							break;
						case 8: // tJE^
							cmd.Append("CNTR");
							break;
						case 9: // f[^
							cmd.Append("DM  ");
							break;
						case 20: // ώZ^C}
							cmd.Append("TTIM");
							break;
						case 99: // g
							cmd.Append("EM  ");
							break;
						default:
							return false;
					}
				}

				cmd.Append(cmds[i].ch.ToString("0000"));

				if(cmds[i].op < 0)
				{
					cmd.Append("CH");
				}
				else
				{
					cmd.Append(cmds[i].op.ToString("00"));
				}

				if(i != (n - 1))
				{
					cmd.Append(",");
				}

				if((str.Length + cmd.Length + 3) <= 128)
				{
					str.Append(cmd.ToString());
				}
				else
				{
					ar.Add(str.ToString());
					str = new StringBuilder(cmd.ToString());
				}
			}
			ar.Add(str.ToString());
			
			// f[^M
			if(ar.Count == 1)
			{
				rs.SendExsyn((string)(ar[0]), 0);
			}
			else
			{
				for(i = 0; i < ar.Count - 1; i++)
				{
					rs.SendExsyn((string)(ar[i]), 1);
				}
				rs.SendExsyn((string)(ar[i]), 0);
			}

			return true;
		}

		public static string[] ReadQQ(Omron rs)
		{
			StringBuilder str = new StringBuilder("@");
			str.Append(rs.MachineNo.ToString("00"));
			str.Append("QQIR");

			if(rs.Ready == false) return new string[] {"FALSE"};
			
			StringBuilder recData = new StringBuilder(); 

			string ret;
			ret = rs.SendExsyn(str.ToString(), 0);
			if(ret.EndsWith("*"))
			{
				recData.Append(ret.Substring(9, ret.Length - 12));
			}
			else
			{
				if(ret.Length > 2)
				{
					recData.Append(ret.Substring(9, ret.Length - 11));
					while(true)
					{
						ret = rs.SendExsyn("\r", 2);
						if(ret.EndsWith("*"))
						{
							recData.Append(ret.Substring(0, ret.Length - 3));
							break;
						}
						else if(ret.Length > 2)
						{
							recData.Append(ret.Substring(0, ret.Length - 2));
						}
						else
						{
							break;
						}
					}
				}
			}

			string s = recData.ToString();

			return s.Split(',');
		}

	}
}
